> ## Documentation Index
> Fetch the complete documentation index at: https://docs.dfns.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Wallet

> Creates a new Wallet associated with the given chain (such as Bitcoin or Ethereum ). Returns a new wallet entity.



## OpenAPI

````yaml /openapi.yaml post /wallets
openapi: 3.1.0
info:
  version: 1.807.0
  title: Dfns
servers:
  - url: https://api.dfns.io
    description: Default - Europe
  - url: https://api.uae.dfns.io
    description: UAE
  - url: https://api.dfns.ninja
    description: <Deprecated> Staging
security: []
paths:
  /wallets:
    post:
      tags:
        - Wallets
      summary: Create Wallet
      description: >-
        Creates a new Wallet associated with the given chain (such as Bitcoin or
        Ethereum ). Returns a new wallet entity.
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                network:
                  type: string
                  description: Network used for the wallet.
                  enum:
                    - Algorand
                    - AlgorandTestnet
                    - Aptos
                    - AptosTestnet
                    - ArbitrumOne
                    - ArbitrumSepolia
                    - ArcTestnet
                    - AvalancheC
                    - AvalancheCFuji
                    - BabylonGenesis
                    - BabylonTestnet5
                    - Base
                    - BaseSepolia
                    - Berachain
                    - BerachainBepolia
                    - Bitcoin
                    - BitcoinSignet
                    - BitcoinTestnet3
                    - BitcoinCash
                    - Bob
                    - BobSepolia
                    - Bsc
                    - BscTestnet
                    - Canton
                    - CantonTestnet
                    - Cardano
                    - CardanoPreprod
                    - Concordium
                    - ConcordiumTestnet
                    - Celo
                    - CeloAlfajores
                    - Codex
                    - CodexSepolia
                    - CosmosHub4
                    - CosmosIcsTestnet
                    - Dogecoin
                    - DogecoinTestnet
                    - Ethereum
                    - EthereumClassic
                    - EthereumClassicMordor
                    - EthereumSepolia
                    - EthereumHolesky
                    - EthereumHoodi
                    - FantomOpera
                    - FantomTestnet
                    - FlareC
                    - FlareCCoston2
                    - FlowEvm
                    - FlowEvmTestnet
                    - Hedera
                    - HederaTestnet
                    - Ink
                    - InkSepolia
                    - InternetComputer
                    - Ion
                    - IonTestnet
                    - Iota
                    - IotaTestnet
                    - Kaspa
                    - Kusama
                    - KusamaAssetHub
                    - Litecoin
                    - LitecoinTestnet
                    - Near
                    - NearTestnet
                    - Optimism
                    - OptimismSepolia
                    - Origyn
                    - Plasma
                    - PlasmaTestnet
                    - Plume
                    - PlumeSepolia
                    - Paseo
                    - PaseoAssetHub
                    - Polkadot
                    - PolkadotAssetHub
                    - Polygon
                    - PolygonAmoy
                    - Polymesh
                    - PolymeshTestnet
                    - Race
                    - RaceSepolia
                    - SeiAtlantic2
                    - SeiPacific1
                    - Solana
                    - SolanaDevnet
                    - Starknet
                    - StarknetSepolia
                    - Stellar
                    - StellarTestnet
                    - Sui
                    - SuiTestnet
                    - Tezos
                    - TezosGhostnet
                    - Tempo
                    - TempoModerato
                    - Tsc
                    - TscTestnet1
                    - Ton
                    - TonTestnet
                    - Tron
                    - TronNile
                    - Westend
                    - WestendAssetHub
                    - Xdc
                    - XdcApothem
                    - XLayer
                    - XLayerSepolia
                    - XrpLedger
                    - XrpLedgerTestnet
                name:
                  type: string
                  maxLength: 100
                  description: Wallet nickname.
                signingKey:
                  type: object
                  properties:
                    id:
                      type: string
                      minLength: 1
                      maxLength: 64
                      pattern: ^key-[a-z0-9]{5}-[a-z0-9]{5}-[a-z0-9]{14,16}$
                      description: >-
                        Use this parameter to create a wallet from an existing
                        key. This enables one key to be used across multiple
                        networks and have the same address if networks share the
                        same address format, ex. `Ethereum` and `Polygon`. If
                        specified, requires the `Keys:Reuse` permission. If the
                        key is delegated to an end user, then the new wallet
                        will be automatically delegated to the same end user.
                      example: key-01snl-t56gb-j8tsok0vn802p80i
                    scheme:
                      allOf:
                        - $ref: '#/components/schemas/KeyScheme'
                        - description: >-
                            Use this to specify the new key scheme for networks
                            that support multiple key formats. ex. use `Schnorr`
                            to create a `Bitcoin Taproot` wallet.
                    curve:
                      allOf:
                        - $ref: '#/components/schemas/KeyCurve'
                        - description: >-
                            Use this to specify the new key curve for networks
                            that support multiple key formats.
                    storeId:
                      type: string
                      description: >-
                        Use this to specify the key store the key material is
                        saved to.
                    deriveFrom:
                      type: object
                      properties:
                        keyId:
                          type: string
                          minLength: 1
                          maxLength: 64
                          pattern: ^key-[a-z0-9]{5}-[a-z0-9]{5}-[a-z0-9]{14,16}$
                          description: The master key to derive from.
                          example: key-01snl-t56gb-j8tsok0vn802p80i
                        path:
                          type: string
                          pattern: ^m(\/(0|[1-9]\d{0,9}))+$
                          description: >-
                            Use this to specify the derivation path of the
                            signing key. One will be auto generated if left
                            blank.
                      required:
                        - keyId
                      description: Use this for hierarchical deterministic key derivation.
                  description: Options for the wallet's underlying key
                delegateTo:
                  type: string
                  minLength: 1
                  maxLength: 64
                  pattern: ^us-[a-z0-9]{5}-[a-z0-9]{5}-[a-z0-9]{14,16}$
                  description: >-
                    ID of the end user to delegate this wallet to. The wallet
                    will only be usable by the end user. More info
                    [here](https://docs.dfns.co/advanced/delegated-signing).
                  example: us-6b58p-r53sr-rlrd3l5cj3uc4ome
                delayDelegation:
                  type: boolean
                  default: false
                  description: >-
                    Specify if you want to create the wallet from a service
                    account and later [delegate
                    it](/api-reference/keys/delegate-key) to an end user.
                externalId:
                  type: string
                  maxLength: 100
                  description: >-
                    User-defined value that can be used to correlate the entity
                    with an external system
                tags:
                  type: array
                  items:
                    type: string
                    pattern: ^[a-zA-Z0-9_.:/+-]{1,100}$
                    description: Wallet Tag.
                  maxItems: 10
                  description: >-
                    List of tags to be created for this wallet. If specified,
                    requires the `Wallets:Tags:Add` permission, like the [Tag
                    Wallet](https://docs.dfns.co/api-reference/wallets/tag-wallet)
                    endpoint.
              required:
                - network
              additionalProperties: false
            examples:
              Bitcoin Taproot:
                value:
                  network: BitcoinSignet
                  signingKey:
                    scheme: Schnorr
              Multi chain:
                value:
                  network: BaseSepolia
                  signingKey:
                    id: key-b56ng-qm1c8-pqaki69j8jmmafo
              Ethereum:
                value:
                  network: Ethereum
                  name: trading hot wallet
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/Wallet'
                  - additionalProperties: false
      security:
        - authenticationToken: []
          userActionSignature: []
components:
  schemas:
    KeyScheme:
      type: string
      description: The cryptographic scheme for the key.
      enum:
        - ECDSA
        - EdDSA
        - Schnorr
    KeyCurve:
      type: string
      enum:
        - ed25519
        - secp256k1
        - stark
      description: The elliptic curve for the key.
    Wallet:
      type: object
      properties:
        id:
          type: string
          minLength: 1
          maxLength: 64
          pattern: ^wa-[a-z0-9]{5}-[a-z0-9]{5}-[a-z0-9]{14,16}$
          description: ID of the wallet.
          example: wa-5pfuu-9euek-h0odgb6snva8ph3k
        network:
          type: string
          description: Network this wallet is bound to.
          enum:
            - Algorand
            - AlgorandTestnet
            - Aptos
            - AptosTestnet
            - ArbitrumOne
            - ArbitrumSepolia
            - ArcTestnet
            - AvalancheC
            - AvalancheCFuji
            - BabylonGenesis
            - BabylonTestnet5
            - Base
            - BaseSepolia
            - Berachain
            - BerachainBepolia
            - Bitcoin
            - BitcoinSignet
            - BitcoinTestnet3
            - BitcoinCash
            - Bob
            - BobSepolia
            - Bsc
            - BscTestnet
            - Canton
            - CantonTestnet
            - Cardano
            - CardanoPreprod
            - Concordium
            - ConcordiumTestnet
            - Celo
            - CeloAlfajores
            - Codex
            - CodexSepolia
            - CosmosHub4
            - CosmosIcsTestnet
            - Dogecoin
            - DogecoinTestnet
            - Ethereum
            - EthereumClassic
            - EthereumClassicMordor
            - EthereumSepolia
            - EthereumHolesky
            - EthereumHoodi
            - FantomOpera
            - FantomTestnet
            - FlareC
            - FlareCCoston2
            - FlowEvm
            - FlowEvmTestnet
            - Hedera
            - HederaTestnet
            - Ink
            - InkSepolia
            - InternetComputer
            - Ion
            - IonTestnet
            - Iota
            - IotaTestnet
            - Kaspa
            - Kusama
            - KusamaAssetHub
            - Litecoin
            - LitecoinTestnet
            - Near
            - NearTestnet
            - Optimism
            - OptimismSepolia
            - Origyn
            - Plasma
            - PlasmaTestnet
            - Plume
            - PlumeSepolia
            - Paseo
            - PaseoAssetHub
            - Polkadot
            - PolkadotAssetHub
            - Polygon
            - PolygonAmoy
            - Polymesh
            - PolymeshTestnet
            - Race
            - RaceSepolia
            - SeiAtlantic2
            - SeiPacific1
            - Solana
            - SolanaDevnet
            - Starknet
            - StarknetSepolia
            - Stellar
            - StellarTestnet
            - Sui
            - SuiTestnet
            - Tezos
            - TezosGhostnet
            - Tempo
            - TempoModerato
            - Tsc
            - TscTestnet1
            - Ton
            - TonTestnet
            - Tron
            - TronNile
            - Westend
            - WestendAssetHub
            - Xdc
            - XdcApothem
            - XLayer
            - XLayerSepolia
            - XrpLedger
            - XrpLedgerTestnet
        address:
          type: string
          description: Wallet address on its corresponding network.
        signingKey:
          type: object
          properties:
            id:
              type: string
              minLength: 1
              maxLength: 64
              pattern: ^key-[a-z0-9]{5}-[a-z0-9]{5}-[a-z0-9]{14,16}$
              description: Key id.
              example: key-01snl-t56gb-j8tsok0vn802p80i
            scheme:
              $ref: '#/components/schemas/KeyScheme'
            curve:
              $ref: '#/components/schemas/KeyCurve'
            publicKey:
              type: string
              description: Hex-encoded value of the public key.
              example: >-
                e2375c8c9e87bfcd0be8f29d76c818cabacd51584f72cb2222d49a13b036d84d3d
            delegatedTo:
              type: string
              minLength: 1
              maxLength: 64
              pattern: ^us-[a-z0-9]{5}-[a-z0-9]{5}-[a-z0-9]{14,16}$
              description: The end user ID the key (and wallet) is delegated to.
              example: us-6b58p-r53sr-rlrd3l5cj3uc4ome
          required:
            - id
            - scheme
            - curve
            - publicKey
          description: Details about the key underlying the wallet.
        status:
          type: string
          enum:
            - Active
            - Inactive
            - Archived
          description: Wallet status.
        dateCreated:
          type: string
          description: >-
            [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) date string when
            wallet was created.
          example: '2023-04-14T20:41:28.715Z'
        dateDeleted:
          type: string
          description: >-
            [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) date string when
            wallet was deleted.
          example: '2023-04-14T20:41:28.715Z'
        name:
          type: string
          maxLength: 100
          description: Wallet nickname.
        custodial:
          type: boolean
          description: >-
            Whether the wallet is owned by an end user (non-custodial), or by
            your organization (custodial).
        externalId:
          type: string
          maxLength: 100
          description: >-
            User-defined value that can be used to correlate the entity with an
            external system.
        tags:
          type: array
          items:
            type: string
            pattern: ^[a-zA-Z0-9_.:/+-]{1,100}$
            description: Wallet Tag.
          maxItems: 10
          description: List of tags.
        validatorId:
          type: string
          minLength: 1
          maxLength: 64
          pattern: ^cv-[a-z0-9]{5}-[a-z0-9]{5}-[a-z0-9]{14,16}$
          description: >-
            Id of the validator on which the wallet is created for Canton
            networks
          example: cv-7jeof-m584r-p35ucm37ko3cqgts
      required:
        - id
        - network
        - signingKey
        - status
        - dateCreated
        - custodial
        - tags
      example:
        id: wa-1f04s-lqc9q-xxxxxxxxxxxxxxxx
        network: Ethereum
        address: '0x00e3495cf6af59008f22ffaf32d4c92ac33dac47'
        name: trading hot wallet
        signingKey:
          id: key-6ece3-9l565-xxxxxxxxxxxxxxxx
          scheme: ECDSA
          curve: secp256k1
          publicKey: e2375c8c9e87bfcd0be8f29d76c818cabacd51584f72cb2222d49a13b036d84d3d
        status: Active
        dateCreated: '2023-04-14T20:41:28.715Z'
        custodial: true
        tags: []
  securitySchemes:
    authenticationToken:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: >-
        **Bearer Token:** Used to authenticate API requests.

        More details how to generate the token: [Authentication
        flows](https://docs.dfns.co/api-reference/auth/login-flows)
    userActionSignature:
      type: apiKey
      in: header
      name: X-DFNS-USERACTION
      description: >-
        **User Action Signature:** Used to sign the change-inducing API
        requests.

        More details how to generate the token: [User Action Signing
        flows](https://docs.dfns.co/api-reference/auth/signing-flows)

````